//----------------------------------------------------------------------//
// NyanFi																//
//  L[															//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include "usr_key.h"
#include "Global.h"
#include "FindKey.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFindKeyDlg *FindKeyDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TFindKeyDlg::TFindKeyDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFindKeyDlg::FormShow(TObject *Sender)
{
	TwoStrCheckBox->Checked	= IniFile->ReadBoolGen(_T("FindKeyTwoStr"));
	KeyStr = EmptyStr;
	DummyBtn->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TFindKeyDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->WriteBoolGen(_T("FindKeyTwoStr"),	TwoStrCheckBox);

	if (ModalResult!=mrOk) KeyStr = EmptyStr;
}

//---------------------------------------------------------------------------
void __fastcall TFindKeyDlg::WmMenuChar(TMessage &msg)
{
	if (msg.WParamHi==MF_POPUP)
		TForm::Dispatch(&msg);
	else
		msg.Result = (MNC_CLOSE << 16);		//r[vȂ悤ɂ
}

//---------------------------------------------------------------------------
//ENTERȊÕL[
//---------------------------------------------------------------------------
void __fastcall TFindKeyDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString key_str = get_KeyStr(Key);
	if (!key_str.IsEmpty()) {
		if (KeyStr.IsEmpty()) {
			KeyStr = get_ShiftStr(Shift) + key_str;
			if (!TwoStrCheckBox->Enabled || !TwoStrCheckBox->Checked) ModalResult = mrOk;
		}
		else {
			KeyStr.cat_sprintf(_T("~%s"), key_str.c_str());
			ModalResult = mrOk;
		}
	}

	Key = 0;
}
//---------------------------------------------------------------------------
//ENTERL[̏ (DummyBtn Ŏ󂯎)
//---------------------------------------------------------------------------
void __fastcall TFindKeyDlg::DummyBtnClick(TObject *Sender)
{
	UnicodeString key_str = "ENTER";
	UnicodeString sft_str;
	if (is_KeyDown(VK_SHIFT))	sft_str += KeyStr_Shift;
	if (is_KeyDown(VK_CONTROL))	sft_str += KeyStr_Ctrl;
	if (is_KeyDown(VK_MENU))	sft_str += KeyStr_Alt;

	if (KeyStr.IsEmpty()) {
		KeyStr = sft_str + key_str;
		if (!TwoStrCheckBox->Enabled || !TwoStrCheckBox->Checked) ModalResult = mrOk;
	}
	else {
		KeyStr.cat_sprintf(_T("~%s"), key_str.c_str());
		ModalResult = mrOk;
	}
}

//---------------------------------------------------------------------------
void __fastcall TFindKeyDlg::TwoStrCheckBoxClick(TObject *Sender)
{
	DummyBtn->SetFocus();
}

//---------------------------------------------------------------------------
void __fastcall TFindKeyDlg::CancelBtnClick(TObject *Sender)
{
	ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

